// ----------------------------------------------------------------------------------
//
// roboFish.c                                                  Ulrich Mller 16.02.06
//                                                             PCS1700 Renesas C 4.00
// Betriebs-Routinen auf Basis der TransferArea
//
// ----------------------------------------------------------------------------------

#include "TA_Firmware\TAF_00D.h";
#include "TA_Firmware\TAF_00P.h";
#include "roboFish.h";

void InitFish(void) {                 // --- Initialisierung
    UINT i;
	for(i = 0; i < 8; i++) sTrans.MPWM_Main[0] = 7;  // --- Default Power
	sTrans.MPWM_Update = 0x01;        // --- Update PWM alle 10 ms
}

BOOL GetInput(UINT InputNr) {         // --- Abfrage I-Eingang
  return sTrans.E16_Main[--InputNr] ? TRUE : FALSE;
}

UINT GetAnalog(UINT AnalogNr) {
  switch(AnalogNr) {
	  case 0: return sTrans.AX; break;
		case 1: return sTrans.AY; break;
		default: return 0;
	}
}

UINT GetVoltage(UINT VoltNr) {
  switch(VoltNr) {
	  case 0: return sTrans.A1; break;
		case 1: return sTrans.A2; break;
		default: return 0;
	}
}

void SetMotor(UINT MotorNr, UINT Dir) {  // --- Schalten MotorAusgang mit fester Speed
  UINT n = --MotorNr << 1;
  sTrans.M_Main &= ~(3 << n);      // --- Richtung lschen
  switch (Dir) {                   //              setzen
    case 0: break;
	case 1: sTrans.M_Main |= 1 << n; break;  // --- Links
	case 2: sTrans.M_Main |= 2 << n; break;  // --- Rechts
  }
}

void WaitForChange(UINT InputNr, UINT NrOfChanges) { // --- Warten auf Anzahl Impulse
  UINT INew, IOld;
  InputNr--;
  IOld = sTrans.E16_Main[InputNr];                   // --- Merken Ausgangsstand des Eingangs
  do {
    INew = sTrans.E16_Main[InputNr];                 // --- Feststellen aktueller Stand
	if(INew != IOld) { IOld = INew; NrOfChanges--;}  // --- Abfrage auf Vernderung
  } while(NrOfChanges);                              // --- Loopende, wenn NrOfChanges = 0
}